#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using Syncfusion.Runtime.Serialization;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Tools;

namespace SimpleCode
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : Form
    {
        private DockingManager mDockingManager2;
        private HostContainer mHostContainer1;
        private ImageList ilDocking;
        private ToolStripMenuItem switchToolStripMenuItem;
        private ToolStripMenuItem chaneCaptionToolStripMenuItem;
        private IContainer components;
        private Panel panel1;
        private ComboBox cmbLayouts;
        private Label label1;
	    private Dictionary<string, LayoutConfig> mLayoutConfigs = new Dictionary<string, LayoutConfig>();
        private string mLastSelection = "";

        //private static int mUniqueId = 0;

		public Form1()
		{
			//
			// Required for Windows Form Designer support.
			//
			InitializeComponent();

			// The InitalizeDockingWindows method programmatically initializes the DockingManager 
			// and the various dockable controls.
			InitializeDockingWindows();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container( );
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager( typeof( Form1 ) );
            this.ilDocking = new System.Windows.Forms.ImageList( this.components );
            this.switchToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem( );
            this.chaneCaptionToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem( );
            this.panel1 = new System.Windows.Forms.Panel( );
            this.cmbLayouts = new System.Windows.Forms.ComboBox( );
            this.label1 = new System.Windows.Forms.Label( );
            this.panel1.SuspendLayout( );
            this.SuspendLayout( );
            // 
            // ilDocking
            // 
            this.ilDocking.ImageStream = ( (System.Windows.Forms.ImageListStreamer)( resources.GetObject( "ilDocking.ImageStream" ) ) );
            this.ilDocking.TransparentColor = System.Drawing.Color.Transparent;
            this.ilDocking.Images.SetKeyName( 0, "" );
            this.ilDocking.Images.SetKeyName( 1, "" );
            this.ilDocking.Images.SetKeyName( 2, "" );
            this.ilDocking.Images.SetKeyName( 3, "" );
            this.ilDocking.Images.SetKeyName( 4, "" );
            this.ilDocking.Images.SetKeyName( 5, "" );
            this.ilDocking.Images.SetKeyName( 6, "" );
            this.ilDocking.Images.SetKeyName( 7, "" );
            // 
            // switchToolStripMenuItem
            // 
            this.switchToolStripMenuItem.Name = "switchToolStripMenuItem";
            this.switchToolStripMenuItem.Size = new System.Drawing.Size( 32, 19 );
            // 
            // chaneCaptionToolStripMenuItem
            // 
            this.chaneCaptionToolStripMenuItem.Name = "chaneCaptionToolStripMenuItem";
            this.chaneCaptionToolStripMenuItem.Size = new System.Drawing.Size( 32, 19 );
            // 
            // panel1
            // 
            this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.panel1.Controls.Add( this.label1 );
            this.panel1.Controls.Add( this.cmbLayouts );
            this.panel1.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.panel1.Location = new System.Drawing.Point( 0, 411 );
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size( 813, 35 );
            this.panel1.TabIndex = 0;
            // 
            // cmbLayouts
            // 
            this.cmbLayouts.Cursor = System.Windows.Forms.Cursors.IBeam;
            this.cmbLayouts.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cmbLayouts.FormattingEnabled = true;
            this.cmbLayouts.Location = new System.Drawing.Point( 89, 9 );
            this.cmbLayouts.Name = "cmbLayouts";
            this.cmbLayouts.Size = new System.Drawing.Size( 121, 21 );
            this.cmbLayouts.TabIndex = 1;
            this.cmbLayouts.SelectedIndexChanged += new System.EventHandler( this.cmbLayouts_SelectedIndexChanged );
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point( 11, 12 );
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size( 72, 13 );
            this.label1.TabIndex = 2;
            this.label1.Text = "Select Layout";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size( 5, 13 );
            this.BackColor = System.Drawing.Color.FromArgb( ( (int)( ( (byte)( 237 ) ) ) ), ( (int)( ( (byte)( 240 ) ) ) ), ( (int)( ( (byte)( 246 ) ) ) ) );
            this.ClientSize = new System.Drawing.Size( 813, 446 );
            this.Controls.Add( this.panel1 );
            this.Icon = ( (System.Drawing.Icon)( resources.GetObject( "$this.Icon" ) ) );
            this.MaximizeBox = false;
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Simple Code";
            this.Shown += new System.EventHandler( this.Form1_Shown );
            this.panel1.ResumeLayout( false );
            this.panel1.PerformLayout( );
            this.ResumeLayout( false );

		}
		#endregion

		private DockingManager CreateDockingManager(ContainerControl hostContainer)
		{
            DockingManager dockingManager = new DockingManager( );
            dockingManager.EnableContextMenu = true;
            dockingManager.ThemesEnabled = false;
            dockingManager.DragProviderStyle = DragProviderStyle.VS2005;
            dockingManager.PersistState = false;
            dockingManager.DisallowFloating = true;
            dockingManager.AutoHideInterval = 1;
            dockingManager.PaintBorders = true;

            if (hostContainer is Form)
                dockingManager.HostForm = (Form) hostContainer;
            else
                dockingManager.HostControl = hostContainer;

            dockingManager.ThemesEnabled = true;
            dockingManager.VisualStyle = VisualStyle.Office2003;
            dockingManager.PersistState = false;
            dockingManager.EnableContextMenu = true;
            dockingManager.ImageList = ilDocking;
            dockingManager.DockToFill = true;

		    return dockingManager;
		}

        private TestPanel CreateTestPanel( Color backColor, string description, DockingManager dockingManager )
        {
            TestPanel testPanel = new TestPanel( );
            testPanel.Name = description;

            dockingManager.DockControl( testPanel, dockingManager.HostControl, DockingStyle.Left, 200 );
            dockingManager.SetDockLabel( testPanel, description );

            return testPanel;
        }

        private void RemoveAllPanels(DockingManager dockingManager)
        {
            for( int i = dockingManager.ControlsArray.Length - 1; i >= 0; i-- )
            {
                TestPanel panelToBeRemoved = (TestPanel)dockingManager.ControlsArray[i];
                dockingManager.SetEnableDocking(panelToBeRemoved, false);
                panelToBeRemoved.Dispose();
            }
        }
        
        // <samplecodeblock name="DockingWindows">
		// The method demonstrates how to programmatically initialize and set the docking windows layout.
		private void InitializeDockingWindows()
		{
            mHostContainer1 = new HostContainer();
            mHostContainer1.Name = "HostContainer1";
            mHostContainer1.BackColor = Color.BurlyWood;
            Controls.Add( mHostContainer1 );

            mDockingManager2 = CreateDockingManager( mHostContainer1 );

            CreateTestPanel( Color.Green, "TestPanel1", mDockingManager2 );
            CreateTestPanel( Color.Green, "TestPanel2", mDockingManager2 );
            CreateTestPanel( Color.Green, "TestPanel3", mDockingManager2 );

            LayoutConfig newLayoutConfig = new LayoutConfig( );
            newLayoutConfig.SaveConfig( mDockingManager2 );
            mLayoutConfigs.Add( "Test Layout 1", newLayoutConfig );

            newLayoutConfig = new LayoutConfig( );
            newLayoutConfig.SaveConfig( mDockingManager2 );
            mLayoutConfigs.Add( "Test Layout 2", newLayoutConfig );

            foreach( KeyValuePair<string, LayoutConfig> pair in mLayoutConfigs )
                cmbLayouts.Items.Add(pair.Key);

		    cmbLayouts.SelectedIndex = 1;
        }

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		public static void Main() 
		{
			Application.Run(new Form1());
		}

        private void Form1_Shown( object sender, EventArgs e )
        {
            panel1.Dock = DockStyle.Bottom;
            mHostContainer1.Dock = DockStyle.Fill;
            mHostContainer1.BringToFront();

        }

        private void cmbLayouts_SelectedIndexChanged( object sender, EventArgs e )
        {
            LayoutConfig currentLayout;

            if (mLastSelection != "")
            {
                currentLayout = mLayoutConfigs[mLastSelection];
                currentLayout.SaveConfig( mDockingManager2 );
            }

            RemoveAllPanels( mDockingManager2 );

            currentLayout = mLayoutConfigs[cmbLayouts.Text];
            currentLayout.LoadConfig( mDockingManager2 );
            mLastSelection = cmbLayouts.Text;
        }
	}
}
