using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Runtime.Serialization;
using Syncfusion.Windows.Forms.Tools;

namespace SimpleCode
{
    class LayoutConfig
    {
        private List<string> mPanelNamesList = new List<string>( );
        private byte[] mDockingState;

        public void SaveConfig( DockingManager dockingManager )
        {
            mPanelNamesList.Clear( );

            for( int i = 0; i < dockingManager.ControlsArray.Length; i++ )
                mPanelNamesList.Add( dockingManager.ControlsArray[i].Name );


            MemoryStream ms = new MemoryStream( );
            AppStateSerializer serializer = new AppStateSerializer( SerializeMode.XMLFmtStream, ms );

            dockingManager.SaveDockState( serializer );
            serializer.PersistNow( );

            mDockingState = ms.ToArray( );
        }

        public void LoadConfig( DockingManager dockingManager )
        {
            foreach( string s in mPanelNamesList )
            {
                TestPanel testPanel = new TestPanel( );
                testPanel.Name = s;

                dockingManager.DockControl( testPanel, dockingManager.HostControl, DockingStyle.Left, 200 );
                dockingManager.SetDockLabel( testPanel, s );

            }


            MemoryStream ms = new MemoryStream( mDockingState );
            AppStateSerializer serializer = new AppStateSerializer( SerializeMode.XMLFmtStream, ms );

            if( !dockingManager.LoadDockState( serializer ) )
                MessageBox.Show( "Loading the docking state failed" );

        }
    }
}
